		org	100h

		mov	ax,3
		int	10h

		mov	ax,0B800h
		mov	es,ax

main:
		call	display

		mov	ah,1
		int	16h
		jz	main

		mov	ah,0
		int	16h

		mov	[key],ax

		cmp	ah,71		; Home
		jz	key_home
		cmp	ah,72		; Up
		jz	key_up
		cmp	ah,73           ; PgUp
		jz	key_pgup
		cmp	ah,84h          ; Ctrl-PgUp
		jz	key_cpgup
		cmp	ah,75           ; Left
		jz	key_left
		cmp	ah,77           ; Right
		jz	key_right
		cmp	ah,80		; Down
		jz	key_down
		cmp	ah,81		; PgDn
		jz	key_pgdn
		cmp	ah,76h		; Ctrl-PgDn
		jz	key_cpgdn
		cmp	al,'d'		; 'd'
		jz	key_d
		cmp	ah,1		; ESC
		jz	exit
		jmp	main

key_home:	mov	word [pos],0
		mov	word [pos + 2],0
		jmp	main
key_up:		dec	word [pos + 2]
		jmp	main
key_pgup:	sub	word [pos + 2],23
		jmp	main
key_cpgup:	sub	word [pos + 2],1000h
		jmp	main
key_left:	dec	word [pos]
		jmp	main
key_right:	inc	word [pos]
		jmp	main
key_down:	inc	word [pos + 2]
		jmp	main
key_pgdn:	add	word [pos + 2],23
		jmp	main
key_cpgdn:	add	word [pos + 2],1000h
		jmp	main
key_d:		mov	word [pos + 2],cs
		jmp	main

exit:
		mov	ax,3
		int	10h

		int	20h
;-------------------------------------------------------------------------------
display:	xor	di,di
		mov	byte [attr],03Ah
		lea	si,[Title]
		call	emitstr
		call	clreol

		mov	ax,[pos]
		mov	[cur],ax
		mov	ax,[pos + 2]
		mov	[cur + 2],ax

		mov	cx,23
oneline:	call	displayline
		loop	oneline

		mov	byte [attr],03Ah

		lea	si,[Subtitle]
		call	emitstr
		call	clreol

		ret

displayline:
		mov	byte [attr],01Fh

		mov	al,179			; ' '
		call	emit

		mov	ax,[cur]
		mov	[_cur],ax
		mov	ax,[cur + 2]
		mov	[_cur + 2],ax

		mov	ax,[cur + 2]
		call	emithexw
		mov	al,':'
		call	emit
		mov	ax,[cur]
		call	emithexw

		mov	al,179			; ' '
		call	emit

		push	cx

		mov	byte [attr],01Eh
		call	emitspace

		mov	cx,16
dl_loop1:	push	es
		mov	es,[cur + 2]
		mov	si,[cur]
		mov	al,[es:si]
		pop	es
		call	emithexb

		call	emitspace

		cmp	cx,9
		jnz	dl_loop1.skip
		call	emitspace
		call	emitspace
.skip:
		inc	word [cur]
		jnz	dl_cont1
		inc	word [cur + 2]
dl_cont1:	loop	dl_loop1

		mov	byte [attr],01Fh
		mov	al,179			; ' '
		call	emit
		mov	byte [attr],01Eh

		mov	ax,[_cur]
		mov	[cur],ax
		mov	ax,[_cur + 2]
		mov	[cur + 2],ax

		mov	cx,16
dl_loop2:	push	es
		mov	es,[cur + 2]
		mov	si,[cur]
		mov	al,[es:si]
		pop	es
		call	emit
		inc	word [cur]
		jnz	dl_cont2
		inc	word [cur + 2]
dl_cont2:	loop	dl_loop2

		pop	cx

		mov	byte [attr],01Fh
		mov	al,179			; ' '
		call	emit

		ret
_cur		dd	0

; al - char, di - position
emit:		cld
		mov	ah,[attr]
		stosw
		ret

; al - char, di - position, cx - length
emitseq:	jcxz	emitseq.exit
.loop:		call	emit
		loop	.loop
.exit:		ret

; si - zero-terminated string
emitstr:	lodsb
		test	al,al
		jz	emitstr.exit
		call	emit
		jmp	emitstr
.exit:		ret

; di - position
emitspace:	push	ax
		push	cx
		mov	al,32
		call	emit
		pop	cx
		pop	ax
		ret

; di - position
clreol:		push	ax
		push	cx
		push	dx
		xor	dx,dx
		mov	ax,di
		shr	ax,1
		mov	cx,80
		div	cx
		sub	cx,dx
		mov	al,32
		call	emitseq
		pop	dx
		pop	cx
		pop	ax
		ret

; al - number, di - position
emithexb:	push	bx
		lea	bx,[hextab]
		push	ax
		shr	al,4
		xlatb
		call	emit
		pop	ax
		and	al,0Fh
		xlatb
		call	emit
		pop	bx
		ret

; aw - number, di - position
emithexw:	push	ax
		mov	al,ah
		call	emithexb
		pop	ax
		call	emithexb
		ret

key		dw	0

hextab		db	'0123456789ABCDEF'		
attr		db	70h

pos		dd	0
cur		dd	0

Title		db	' Memory Viewer:', 0
Subtitle	db	' Motion: Up,Down - one string; PgUp, PgDn - one screen; ^PgUp, ^PgDn - 64k', 0
